#include <ESP8266WiFi.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"
#include <esp8266-google-home-notifier.h>

#define WIFI_SSID "LBello"
#define WIFI_PASS "sifra123"

#define MQTT_SERV "io.adafruit.com"
#define MQTT_PORT 1883
#define MQTT_NAME "VoCom"
#define MQTT_PASS "7ec7f6fc12f546e9962a6d48f6576f4d"

#define RED_LED 5
#define GREEN_LED 15 
#define BUTTON 4 
GoogleHomeNotifier ghn;

int switchState = 0;
int oldSwitchState = 0;

WiFiClient client;
Adafruit_MQTT_Client mqtt(&client, MQTT_SERV, MQTT_PORT, MQTT_NAME, MQTT_PASS);
Adafruit_MQTT_Subscribe onoff = Adafruit_MQTT_Subscribe(&mqtt, MQTT_NAME "/f/Door");
Adafruit_MQTT_Publish ONvalue = Adafruit_MQTT_Publish(&mqtt, MQTT_NAME "/feeds/Door");

void setup() {
  pinMode(RED_LED, OUTPUT);
  pinMode(GREEN_LED, OUTPUT);
  pinMode(BUTTON, INPUT);
  digitalWrite(RED_LED, LOW);
  digitalWrite(GREEN_LED, LOW);
  WiFi.begin(WIFI_SSID, WIFI_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(">");
    delay(50);
  }
  mqtt.subscribe(&onoff); 
  const char displayName[] = "Dnevna soba";

  Serial.println("connecting to Google Home...");
  if (ghn.device(displayName, "en") != true) {
    Serial.println(ghn.getLastError());
    return;
  }
  Serial.print("found Google Home(");
  Serial.print(ghn.getIPAddress());
  Serial.print(":");
  Serial.print(ghn.getPort());
  Serial.println(")");
  
  if (ghn.notify("Hello, World!") != true) {
    Serial.println(ghn.getLastError());
    return;
  }
  Serial.println("Done.");
    
}

void loop() {
  MQTT_connect();
  digitalWrite(RED_LED, LOW);
  switchState = digitalRead(BUTTON);
  if (switchState != oldSwitchState){
    if (ghn.notify("Someone is at the door!") != true) {
        Serial.println(ghn.getLastError());
    }
    switchState = 0;
    digitalWrite(RED_LED, HIGH);
    Adafruit_MQTT_Subscribe * subscription;
    while ((subscription = mqtt.readSubscription(30000))) {
      if (subscription == &onoff){
        Serial.println((char*) onoff.lastread);
        if (!strcmp((char*) onoff.lastread, "UNLOCK")) {
            digitalWrite(RED_LED, LOW);
            digitalWrite(GREEN_LED, HIGH);
            delay(2000);
            digitalWrite(GREEN_LED, LOW);
            ONvalue.publish("LOCKED");
            break;
           }
     }
     else if(subscription == NULL){
          break;
         }
    }
  }
}
  

void MQTT_connect()
{
  //  // Stop if already connected
  if (mqtt.connected() && mqtt.ping())
  {
    //    mqtt.disconnect();
    return;
  }

  int8_t ret;

  mqtt.disconnect();

  Serial.print("Connecting to MQTT... ");
  uint8_t retries = 3;
  while ((ret = mqtt.connect()) != 0) // connect will return 0 for connected
  {
    Serial.println(mqtt.connectErrorString(ret));
    Serial.println("Retrying MQTT connection in 5 seconds...");
    mqtt.disconnect();
    delay(5000);  // wait 5 seconds
    retries--;
    if (retries == 0)
    {
      ESP.reset();
    }
  }
  Serial.println("MQTT Connected!");

}
